//---------------------------------------------------------------------------
// program sluzacy do konwersji wejsciowych plikow graficznych w formacie
// interleaved RAW (RGB888) do trybu RAW RGB565
// autor: Mikula Slawomir (smikula@silesianet.pl)
//
// (c) 2003 - released under GNU GPL license (see www.gnu.org)


#pragma hdrstop

#include <io.h>
#include <stdlib.h>
#include <stdio.h>

//---------------------------------------------------------------------------

#pragma argsused

// glowna petla programu
// kody wyjscia:
//      0 -  program zakonczyl pomyslnie konwersje
//      1 -  wyjscie z bledem (blad otwarcia/utworzenia plikow)
int main(int argc, char* argv[])
{

// deklaracja zmiennych

        FILE *file_desc1, *file_desc2;  //      wskazniki do plikow we, wy
        int sizeoffile, temp=0;         //      wielkosc pliku, zmienna tymczasowa
        unsigned char R,G,B;            //      wartosci odczytane z pliku WE
        unsigned char byte1,byte2;      //      bajty do zapisu
        unsigned char maskaRB = 0xF8;   //      11111000B
        unsigned char maskaG = 0xFC;    //      11111100B
        unsigned char bufor;            //      tymczasowy bufor na obliczenia bitowe


// opcje otwwarcia plikow, ew. wyjscie z programu przy wykryciu bledu
     if (argc==3){
             if ((file_desc1=fopen(*++argv, "rb")) == NULL ) {
              printf("Nie ma pliku %s\n",*argv);
              return 1 ;
             }
             if ((file_desc2=fopen(*++argv,"wb")) ==NULL ) {
              printf("Nie podales pliku wyjsciowego !!!\n Wykonanie : %s <plik.wej> <plik.wyj> ",argv[0]);
              return 1;
             }


// odczyt wielkosci pliku, ustawienie wskaznikow na poczatek pliku
    fseek(file_desc1,0,2);
    sizeoffile=ftell(file_desc1);
    fseek(file_desc1,0,0);

    do	{
        // odczyt trzech bajtow kolorow R, G, B
       fread(&R,1,1,file_desc1);
       fread(&G,1,1,file_desc1);
       fread(&B,1,1,file_desc1);
       temp +=3;        // zwiekszenie wskaznika odczytu

        // operacje na bitach
        R = R & maskaRB;        // uzycie tylko 5 MSB bitow
        G = G & maskaG;         // uzycie tylko 6 MSB bitow
        B = B & maskaRB;        // uzycie tylko 5 MSB bitow
        B = B >> 3 ;

        // operacje laczenia wartosci R G B w porcje 2-bajtowe (format RGB565)
        // format koncowy : |BBBBBGGG|GGGRRRRR|

        bufor = G & 0xE0;       //B11100000
        bufor = bufor >> 5;
        bufor = bufor & 0x07;   //B00000111
        byte1 = B ^ bufor;

        bufor = G & 0x1C ;      //B00011100
        bufor = bufor << 3;
        bufor = bufor & 0xE0;   //B11100000
        byte2 = R ^ bufor;

        // zapis obliczonych bajtow do pliku wyjsciowego
       fwrite(&byte1,1,1,file_desc2);
       fwrite(&byte2,1,1,file_desc2);


    } while(temp<sizeoffile);

     //zamkniecie plikow, zwolnienie wskaznikow
     fclose(file_desc1);
     fclose(file_desc2);

     //kod wyjscia
     return 0;
    }else {
        // informacje nt. uruchomienia programu
        printf("Wykonanie programu: %s <plik.we> <plik.wy>",argv[0]);
        return 0;
        }

}
//---------------------------------------------------------------------------
